"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const discord_js_1 = require("discord.js");
const SimpleLogger_1 = __importDefault(require("./classes/SimpleLogger"));
const AutoRegister_1 = __importDefault(require("./functions/AutoRegister"));
// @Exclude-API
class App {
    client;
    commands = new discord_js_1.Collection();
    config = new discord_js_1.Collection();
    commandSettings;
    constructor(client, token, commandSettings) {
        this.client = client;
        this.commandSettings = commandSettings;
        this.start(token);
    }
    async start(token) {
        await this.client.login(token);
        (0, AutoRegister_1.default)(this).then(() => SimpleLogger_1.default.log("AutoRegister Complete"));
        this.onCommand();
    }
    onCommand() {
        this.client.on("interactionCreate", async (interaction) => {
            if (!interaction.isCommand())
                return;
            const name = interaction.commandName;
            const command = this.commands.get(name);
            if (!command)
                return;
            if (interaction.guild == null)
                return;
            await command.init(interaction.member, interaction.guild, interaction.channel, interaction);
            command.execute(this, interaction);
        });
    }
    getCommandSettings() {
        return this.commandSettings;
    }
}
exports.default = App;
