import { CommandInteraction, Guild, GuildMember, PermissionResolvable, TextChannel } from "discord.js";
import App from "../App";
import { Response } from "../types/Types";
export default abstract class SimpleCommand {
    name: string;
    description: string;
    options: [];
    private _member;
    private _guild;
    private _channel;
    private interaction;
    constructor(name: string, description: string, options?: []);
    init(member: GuildMember, guild: Guild, channel: TextChannel, interaction: CommandInteraction): Promise<boolean>;
    abstract execute(app?: App, interaction?: CommandInteraction): Promise<any>;
    get member(): GuildMember;
    get channel(): TextChannel;
    get guild(): Guild;
    checkPermission(permission: PermissionResolvable): boolean;
    checkRole(roleReference: string): import("discord.js").Role;
    checkRoles(roleReferences: string[]): boolean;
    isOwner(): boolean;
    getChannelType(): "GUILD_TEXT";
    reply(response: Response): Promise<void>;
}
