"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Common_1 = __importDefault(require("../functions/Common"));
// @Exclude-API
class SimpleCommand {
    name;
    description;
    options;
    _member;
    _guild;
    _channel;
    interaction;
    constructor(name, description, options) {
        this.name = name;
        this.description = description;
        this.options = options ?? [];
        this._member = null;
        this._channel = null;
        this._guild = null;
        this.interaction = null;
    }
    async init(member, guild, channel, interaction) {
        this._member = member;
        this._guild = guild;
        this._channel = channel;
        this.interaction = interaction;
        return true;
    }
    get member() {
        return this._member;
    }
    get channel() {
        return this._channel;
    }
    get guild() {
        return this._guild;
    }
    checkPermission(permission) {
        return this.member.permissions.has(permission);
    }
    checkRole(roleReference) {
        return this.member.roles.cache.find(r => r.id == roleReference || r.name == roleReference);
    }
    checkRoles(roleReferences) {
        return roleReferences.some(r => this.member.roles.cache.find(a => a.name == r || a.id == r));
    }
    isOwner() {
        return this.guild.ownerId == this.member.id;
    }
    getChannelType() {
        return this.channel.type;
    }
    reply(response) {
        return Common_1.default.reply(this.interaction, response);
    }
}
exports.default = SimpleCommand;
