"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const discord_js_1 = require("discord.js");
class Common {
    static default;
    static setDefaultEmbed(defaultEmbed) {
        this.default = defaultEmbed;
    }
    static generateEmbed(newEmbedOptions) {
        return this.concatEmbeds(this.default, new discord_js_1.MessageEmbed(newEmbedOptions));
    }
    static concatEmbeds(def, second) {
        if (this.isNull(def.title) && !this.isNull(second.title)) {
            def.title = second.title;
        }
        if (this.isNull(def.description) && !this.isNull(second.description)) {
            def.description = second.description;
        }
        if (this.isNull(def.fields) && !this.isNull(second.fields)) {
            def.fields = second.fields;
        }
        if (this.isNull(def.color) && !this.isNull(second.color)) {
            def.color = second.color;
        }
        if (this.isNull(def.author) && !this.isNull(second.author)) {
            def.author = second.author;
        }
        if (this.isNull(def.footer) && !this.isNull(second.footer)) {
            def.footer = second.footer;
        }
        if (this.isNull(def.thumbnail) && !this.isNull(second.thumbnail)) {
            def.thumbnail = second.thumbnail;
        }
        return def;
    }
    static isNull(val) {
        return val == null || !val || val == "" || val == undefined || val == [] || val == {};
    }
    static async getChannel(guild, channelReference) {
        let channel = guild.channels.cache.find(r => r.name == channelReference || r.id == channelReference);
        if (!channel) {
            guild.channels.fetch(channelReference).then(c => {
                return c || null;
            }).catch(err => {
                return null;
            });
        }
        else {
            return channel || null;
        }
    }
    static async getMember(guild, memberReference) {
        let member = guild.members.cache.get(memberReference);
        if (!member) {
            guild.members.fetch(memberReference).then(c => {
                return c || null;
            }).catch(err => {
                return null;
            });
        }
        else {
            return member || null;
        }
    }
    static async getCategory(guild, id, create) {
        const category = (await this.getChannel(guild, id));
        if (!this.isNull(category) && category.children.size < 49) {
            return {
                isNew: false,
                category: category
            };
        }
        if (create) {
            const channel = await guild.channels.create(category.name, {
                type: "GUILD_CATEGORY"
            });
            return {
                isNew: true,
                category: channel
            };
        }
        else
            return {
                isNew: false,
                category: category
            };
    }
    static reply(interaction, response) {
        if (response.type == "MESSAGE") {
            if (response.content == null) {
                return interaction?.reply("<SimpleCommand>.reply -> Content property is empty (null)");
            }
            return interaction?.reply(response.content);
        }
        if (response.embeds == null || response.embeds.length == 0) {
            return interaction?.reply("<SimpleCommand>.reply -> Embeds array is empty (null)");
        }
        return interaction?.reply({
            embeds: response.embeds
        });
    }
}
exports.default = Common;
